﻿using System;
using System.IO;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;

namespace FeatureGuideCharp
{

	class TestOptionalSignature
    {
        private  String apiKey = "your api key";
        private  String apiUrl = "https://sandbox.esignlive.com/api";

        public  void Execute()
		{
            TestPackageCreation();
            //TestPackageCompletion("packageId");
        }

		public  void TestPackageCreation()
		{
			EslClient eslClient = new EslClient(apiKey, apiUrl);

			FileStream fs1 = File.OpenRead("your file path");
		

			// Build the DocumentPackage object
			DocumentPackage documentPackage = PackageBuilder.NewPackageNamed("Package Name")
					.WithSigner(SignerBuilder.NewSignerWithEmail("signer1@mailinator.com")
							.WithCustomId("Signer1")
							.WithFirstName("Signer1 Name")
							.WithLastName("Signer1 Lastname")
							.WithTitle("Signer1 title")
							.WithCompany("Signer1 company"))
					
					.WithDocument(DocumentBuilder.NewDocumentNamed("document1 name")
							.FromStream(fs1, DocumentType.PDF)
							.WithSignature(SignatureBuilder.SignatureFor("signer1@mailinator.com")
									.OnPage(0)
									.AtPosition(200, 150))
							.WithSignature(SignatureBuilder.InitialsFor("signer1@mailinator.com")
									.AtPosition(200, 350)
									.OnPage(0)
									.MakeOptional())                //optional signature
							)
					.WithoutAutomaticCompletion()
					.Build();

			// Issue the request to the e-SignLive server to create the DocumentPackage
			PackageId packageId = eslClient.CreatePackage(documentPackage);

			// Send the package to be signed by the participants
			eslClient.SendPackage(packageId);
		}
        
        public  void TestPackageCompletion(String packageId)
        {
			EslClient eslClient = new EslClient(apiKey, apiUrl);

            PackageId pId = new PackageId(packageId);

			// Set the package status to Completed when all signatures are signed
			eslClient.PackageService.MarkComplete(pId);

        }
    }
}